function Makequickslots()
	NewQuickslot(1,12,12);
	NewQuickslot(2,1,55);
	NewQuickslot(3,12,99);
	NewQuickslot(4,55,0);
	NewQuickslot(5,55,55);
	NewQuickslot(6,55,108);
	NewQuickslot(7,99,12);
	NewQuickslot(8,108,55);
	NewQuickslot(9,99,99);
	for i=1,9 do --quickslot setting
		Musje.Library.quickslot(MouseGestures.elements.GestureBar.quickslot[i],i);
		MouseGestures.elements.GestureBar.quickslot[i].ShortcutChanged = function(sender,args)
			MouseGestures.data.quickslot[i] = Musje.Library.savequickslot(MouseGestures.elements.GestureBar.quickslot[i],i);
		end
	end
	MouseGestures.elements.GestureBar.quickslot[5]:SetVisible(false);
	MouseGestures.elements.GestureBar.quickslot[5].MouseClick = function(sender,args)
		MouseGestures.elements.GestureBar.quickslot[5]:SetVisible(false);
		MouseGestures.elements.GestureBar.window:SetVisible(false);
	end
	Musje.Library.lock(MouseGestures.elements.GestureBar.quickslot[5]);
end

function NewQuickslot(number,x,y)
	MouseGestures.elements.GestureBar.quickslot[number] = Turbine.UI.Lotro.Quickslot();
	MouseGestures.elements.GestureBar.quickslot[number]:SetParent(MouseGestures.elements.GestureBar.window);
	MouseGestures.elements.GestureBar.quickslot[number]:SetPosition(x,y);
end

function setquickslotmouse(number)
	MouseGestures.data.quickslotmouse = number
end

function getquickslotmouse()
	return MouseGestures.data.quickslotmouse
end

function setdestination(number)
	MouseGestures.data.destination = number
end

function cyclevisible()
	MouseGestures.elements.GestureBar.window:SetVisible(false); -- Properly hiding quickslots
	MouseGestures.elements.GestureBar.window:SetVisible(true); -- Properly hiding quickslots
end

function NewWindow(type)
	if (type == "GestureBar") then
		MouseGestures.elements.GestureBar.window = Turbine.UI.Window();
		MouseGestures.elements.GestureBar.window:SetSize(144,144);
		MouseGestures.elements.GestureBar.window:SetPosition(MouseGestures.data.MidX,MouseGestures.data.MidY);
		MouseGestures.elements.GestureBar.window:SetWantsKeyEvents(true)
		MouseGestures.elements.GestureBar.window.DragDrop = function(sender, args)
			if MouseGestures.data.setup then
				if MouseGestures.data.action == "drag" then
					MouseGestures.data.action = "drop"
					if MouseGestures.data.quickslotmouse == MouseGestures.data.source then
						MouseGestures.data.quickslotmouse = 0
					else
						Musje.Library.PSetShortcut(MouseGestures.elements.GestureBar.quickslot[MouseGestures.data.source],Musje.Library.loadquickslot(MouseGestures.data.quickslots[MouseGestures.data.destination]));
					end
				else 
					MouseGestures.data.action = "drag"
					if MouseGestures.data.destination == nil then
						setdestination(0)
					end
					MouseGestures.data.source = MouseGestures.data.quickslotmouse
					for i=1,9 do
						MouseGestures.data.quickslots[i] = 	MouseGestures.data.quickslot[i]
					end
				end
			end
		end
	elseif (type == "hidden") then
		MouseGestures.elements.hiddenwindow = Turbine.UI.Window();
		MouseGestures.elements.hiddenwindow:SetVisible(false);
		MouseGestures.elements.hiddenwindow:SetWantsKeyEvents(true);
	end
end

function LoadDefaults()
	MouseGestures.data.setup=true;
	MouseGestures.data.gestures=true;
	MouseGestures.data.DisplayWidth, MouseGestures.data.DisplayHeight = Turbine.UI.Display.GetSize();
	MouseGestures.data.MidX = (MouseGestures.data.DisplayWidth/2)-72;
	MouseGestures.data.MidY = (MouseGestures.data.DisplayHeight/2)-72;
	NewWindow("GestureBar");
	Makequickslots();
end

function Message(text)
	Turbine.Shell.WriteLine("<RGB=#a2c1ed>MouseGestures </RGB>"..text);
end

function setsetup(mode)
	if (mode == true) then
		MouseGestures.elements.GestureBar.window:SetVisible(true);
		MouseGestures.data.DisplayWidth, MouseGestures.data.DisplayHeight = Turbine.UI.Display.GetSize();
		MouseGestures.data.MidX = (MouseGestures.data.DisplayWidth/2)-72;
		MouseGestures.data.MidY = (MouseGestures.data.DisplayHeight/2)-72;
		MouseGestures.elements.GestureBar.window:SetPosition(MouseGestures.data.MidX,MouseGestures.data.MidY);
		for i=1,9 do
			MouseGestures.elements.GestureBar.quickslot[i]:SetVisible(true);
			Musje.Library.unlock(MouseGestures.elements.GestureBar.quickslot[i]);
		end
		MouseGestures.elements.GestureBar.quickslot[5]:SetVisible(false);
		Musje.Library.lock(MouseGestures.elements.GestureBar.quickslot[5]);
	elseif (mode == false) then
		for i=1,9 do
			MouseGestures.elements.GestureBar.quickslot[i]:SetVisible(false);
			Musje.Library.lock(MouseGestures.elements.GestureBar.quickslot[i]);
			MouseGestures.elements.GestureBar.window:SetVisible(false);
		end
	end
end

function Gesture(direction)
	if (MouseGestures.data.gestures == true) then
		if direction == "upleft" then
			Gestureshortcut(1);
		elseif direction == "left" then
			Gestureshortcut(2);
		elseif direction == "downleft" then
			Gestureshortcut(3);
		elseif direction == "up" then
			Gestureshortcut(4);
		elseif direction == "down" then
			Gestureshortcut(6);
		elseif direction == "upright" then
			Gestureshortcut(7);
		elseif direction == "right" then
			Gestureshortcut(8);
		elseif direction == "downright" then
			Gestureshortcut(9);
		elseif direction == "nomove" then
			Message("The mouse has not moved enough, please try again.");
			MouseGestures.elements.GestureBar.window:SetVisible(false);
		elseif direction == "error" then
			Message("Error: unknown direction");
			Message("If this problem keeps occuring, please contact the author.");
		end	
	Musje.Library.lock(MouseGestures.elements.GestureBar.quickslot[5]);
	end
end

function Gestureshortcut(number)
	if (MouseGestures.data.gestures == true) then
		MouseGestures.data.mousex , MouseGestures.data.mousey = MouseGestures.elements.hiddenwindow:GetMousePosition();
		MouseGestures.elements.GestureBar.window:SetPosition((MouseGestures.data.mousex-72),(MouseGestures.data.mousey-72));
		MouseGestures.elements.GestureBar.quickslot[5]:SetVisible(true);
		Musje.Library.PSetShortcut(MouseGestures.elements.GestureBar.quickslot[5],Musje.Library.loadquickslot(MouseGestures.data.quickslot[number],number));
	end
end

function Turbine.Plugin:Unload(sender, args)
	save(nil,true)
end

function save(filename,exit)
	if MouseGestures.data.loading then
		Message("Safe failed: Loading not done");
		return;
	end
	if MouseGestures.data.saving then
		return;
	end
	MouseGestures.data.saving=true;
	MouseGestures.data.save = { };
	MouseGestures.data.save.version = 2.25;
	MouseGestures.data.save.setup = MouseGestures.data.setup;
	MouseGestures.data.save.gestures = MouseGestures.data.gestures;
	MouseGestures.data.save.quickslot = { };
	for i=1,9 do
		MouseGestures.data.save.quickslot[i] = MouseGestures.data.quickslot[i];
	end
	MouseGestures.data.save.quickslot[5] = nil;
	MouseGestures.data.runonce = 1;
	Turbine.PluginData.Save(Turbine.DataScope.Account,"MouseGestures",MouseGestures.data.runonce)
	if (filename == nil) then
		filename = "MouseGestures"
	else
		filename = "MouseGestures"..filename
	end
	Turbine.PluginData.Save(Turbine.DataScope.Character,filename,MouseGestures.data.save,function(result,message)
		if result then
			Message("Save successful!")
			if exit then
				clearquickslots()
			else
				MouseGestures.data.saving = false;
			end
		else
			Message("Save failed:"..message)
			if exit then
				clearquickslots()
			else
				MouseGestures.data.saving = false;
			end
		end
	end
	);
end

function load(filename)
	MouseGestures.data.loading = true;
	if filename == nil then
		filename = "MouseGestures"
	else
		filename = "MouseGestures"..filename
	end
	Turbine.PluginData.Load(Turbine.DataScope.Character,filename,function(data)
			MouseGestures.data.load = data
			if (type(MouseGestures.data.load) ~="table") then
				Message("Save file doesn't exist. Please try again")
			else
				if (MouseGestures.data.load.version ~= 2.2) then
					Message("Savedata from version "..MouseGestures.data.load.version.." loaded.");
					Message("To prevent this message from appearing again, please re-save the file using the /MouseGestures save command.");
				end
				for i=1,9 do
					Musje.Library.PSetShortcut(MouseGestures.elements.GestureBar.quickslot[i],Musje.Library.loadquickslot(MouseGestures.data.load.quickslot[i],i));
				end
				MouseGestures.data.setup=MouseGestures.data.load.setup;
				MouseGestures.data.gestures=MouseGestures.data.load.gestures;
				if (MouseGestures.data.setup == false) then
					setsetup(false);
				else
					MouseGestures.data.setup = true;
					setsetup(true);
				end
				Message("Load successful!");
			end
			MouseGestures.data.loading = false;
	end
	);
end	

function clearquickslots()
	if (MouseGestures.data.loading == true) then
		return;
	end
	for i=1,9 do
		MouseGestures.elements.GestureBar.quickslot[i]:SetShortcut(nil);
	end
end



