-- Get mouse start position on pressing the buttons
MouseGestures.elements.hiddenwindow.KeyDown = function(sender, args)
	if (MouseGestures.data.pressed ~= 1) then
		if (MouseGestures.elements.hiddenwindow.IsAltKeyDown() ) and (MouseGestures.elements.hiddenwindow.IsControlKeyDown() ) and (MouseGestures.elements.hiddenwindow.IsShiftKeyDown() ) then
			if (MouseGestures.data.setup == false) then
				MouseGestures.data.pressed = 1;
				MouseGestures.data.mousebx , MouseGestures.data.mouseby = MouseGestures.elements.hiddenwindow:GetMousePosition();
				MouseGestures.data.mousex , MouseGestures.data.mousey = MouseGestures.elements.hiddenwindow:GetMousePosition();
				MouseGestures.elements.GestureBar.window:SetVisible(true);
				MouseGestures.elements.GestureBar.window:SetPosition((MouseGestures.data.mousex-72),(MouseGestures.data.mousey-72));
				for i=1,9 do
					MouseGestures.elements.GestureBar.quickslot[i]:SetVisible(true);
				end
				MouseGestures.elements.GestureBar.quickslot[5]:SetVisible(false);
				MouseGestures.elements.GestureBar.window:SetVisible(false); -- Properly hiding quickslots
				MouseGestures.elements.GestureBar.window:SetVisible(true); -- Properly hiding quickslots
			elseif (args.Action==268435556) or (args.Action==268435575) or (args.Action==268435458) then
				Message("Please disable the setup before using the plugin. (/MouseGestures setup off)");
			end
		end
	end
end

-- Get mouse end position on releasing one of the buttons and calculate the direction
MouseGestures.elements.hiddenwindow.KeyUp = function(sender, args)
	if (MouseGestures.data.pressed == 1) then 
		if (args.Action==268435556) or (args.Action==268435575) or (args.Action==268435458) then --control, shift or alt released
			for i=1,9 do
				MouseGestures.elements.GestureBar.quickslot[i]:SetVisible(false);
			end
			MouseGestures.elements.GestureBar.window:SetVisible(false); -- Properly hiding quickslots
			MouseGestures.elements.GestureBar.window:SetVisible(true); -- Properly hiding quickslots
			if (MouseGestures.data.gestures == false) then
				MouseGestures.elements.GestureBar.window:SetVisible(false);
			end
			MouseGestures.data.pressed = nil; 
			MouseGestures.data.mouseex , MouseGestures.data.mouseey = MouseGestures.elements.hiddenwindow:GetMousePosition();
			MouseGestures.data.movedx = MouseGestures.data.mouseex-MouseGestures.data.mousebx;
			MouseGestures.data.movedy = MouseGestures.data.mouseey-MouseGestures.data.mouseby;
			if MouseGestures.data.movedx >= 0 then
				MouseGestures.data.xpositive = MouseGestures.data.movedx;
			elseif MouseGestures.data.movedx <0 then
				MouseGestures.data.xpositive = -MouseGestures.data.movedx;
			end
			if MouseGestures.data.movedy >= 0 then
				MouseGestures.data.ypositive = MouseGestures.data.movedy;
			elseif MouseGestures.data.movedy <0 then
				MouseGestures.data.ypositive = -MouseGestures.data.movedy;
			end
			if MouseGestures.data.movedx >= 0 then
				if (MouseGestures.data.movedx>(MouseGestures.data.ypositive/2)) then
					MouseGestures.data.right = 1;
					MouseGestures.data.left = 0;
				elseif (MouseGestures.data.movedx<=(MouseGestures.data.ypositive/2)) then
					MouseGestures.data.right = 0;
					MouseGestures.data.left = 0;
				end
			end
			if MouseGestures.data.movedx < 0 then
				if (MouseGestures.data.movedx>=(-(MouseGestures.data.ypositive/2))) then
					MouseGestures.data.right = 0;
					MouseGestures.data.left = 0;
				elseif (MouseGestures.data.movedx<(-(MouseGestures.data.ypositive/2))) then
					MouseGestures.data.right = 0;
					MouseGestures.data.left = 1;
				end
			end 
			if MouseGestures.data.movedy >= 0 then
				if (MouseGestures.data.movedy>(MouseGestures.data.xpositive/2)) then
					MouseGestures.data.down = 1;
					MouseGestures.data.up = 0;
				elseif (MouseGestures.data.movedy<=(MouseGestures.data.xpositive/2)) then
					MouseGestures.data.down = 0;
					MouseGestures.data.up = 0;
				end
			end 
			if MouseGestures.data.movedy < 0 then
				if (MouseGestures.data.movedy>=(-(MouseGestures.data.xpositive/2))) then
					MouseGestures.data.down = 0;
					MouseGestures.data.up = 0;
				elseif (MouseGestures.data.movedy<(-(MouseGestures.data.xpositive/2))) then
					MouseGestures.data.down = 0;
					MouseGestures.data.up = 1;
				end
			end 
			if (((MouseGestures.data.up == 0) and (MouseGestures.data.down == 0)) and ((MouseGestures.data.left == 0) and (MouseGestures.data.right == 0))) then
				Gesture("nomove");
			elseif (((MouseGestures.data.up == 1) and (MouseGestures.data.down == 0)) and ((MouseGestures.data.left == 0) and (MouseGestures.data.right == 0))) then
				Gesture("up");
			elseif (((MouseGestures.data.up == 0) and (MouseGestures.data.down == 1)) and ((MouseGestures.data.left == 0) and (MouseGestures.data.right == 0))) then
				Gesture("down");
			elseif (((MouseGestures.data.up == 0) and (MouseGestures.data.down == 0)) and ((MouseGestures.data.left == 1) and (MouseGestures.data.right == 0))) then
				Gesture("left");
			elseif (((MouseGestures.data.up == 0) and (MouseGestures.data.down == 0)) and ((MouseGestures.data.left == 0) and (MouseGestures.data.right == 1))) then
				Gesture("right");
			elseif (((MouseGestures.data.up == 1) and (MouseGestures.data.down == 0)) and ((MouseGestures.data.left == 1) and (MouseGestures.data.right == 0))) then
				Gesture("upleft");
			elseif (((MouseGestures.data.up == 0) and (MouseGestures.data.down == 1)) and ((MouseGestures.data.left == 1) and (MouseGestures.data.right == 0))) then
				Gesture("downleft");
			elseif (((MouseGestures.data.up == 1) and (MouseGestures.data.down == 0)) and ((MouseGestures.data.left == 0) and (MouseGestures.data.right == 1))) then
				Gesture("upright");
			elseif (((MouseGestures.data.up == 0) and (MouseGestures.data.down == 1)) and ((MouseGestures.data.left == 0) and (MouseGestures.data.right == 1))) then
				Gesture("downright");
			else
				Gesture("error");
			end
		end
	end
end

